// GrabListener 1.0
// Programmed by Jason Zimmer
// Copyright  2004 Dark Knight Software

#include <windows.h>
#include <stdio.h>
#include <richedit.h>

BOOL CALLBACK EnumChildProc(HWND hWnd, LPARAM lParam)
{
	char * Buffer;
	DWORD Length;
	OPENFILENAME ofn = {0};
	char FileName[256] = {0};
	FILE * fp;

	Length = (DWORD)SendMessage(hWnd, WM_GETTEXTLENGTH, 0, 0);
	Buffer = new char [Length + 1];

	SendMessage(hWnd, WM_GETTEXT, Length + 1, (LPARAM)Buffer);

	ofn.lStructSize = sizeof(ofn);
	ofn.lpstrFile = FileName;
	ofn.lpstrFilter = "All Files (*.*)\0*.*\0";
	ofn.nMaxFile = 256;
	ofn.Flags = OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY;

	if(GetSaveFileName(&ofn))
	{
		fp = fopen(FileName, "wb");
		if(fp == NULL)
		{
			printf("Error Opening '%s'\n", FileName);
		}else{
			fwrite(Buffer, strlen(Buffer), 1, fp);
			fclose(fp);
		}
	}

	delete [] Buffer;

	return FALSE;
}

void main(void)
{
	HWND hWnd = FindWindow(NULL, "MAXScript Listener");

	if(hWnd == NULL)
	{
		printf("Error: Could not find Listener window.\nEnsure that you have opened the listener window in GMax.\n");
		return;
	}

	EnumChildWindows(hWnd, EnumChildProc, NULL);
}